part of pegdart;

class Scope {
  
  final Map<Symbol, dynamic> env;
  final Scope outer;
  
  const Scope(this.env, this.outer);
  
  Scope increment() => new Scope({}, this);
  
  dynamic operator [](Symbol key) {
    final dynamic value = env[key];
    return value == null ? outer[key] : value;
  }
  
  void operator []=(Symbol key, dynamic value) { env[key] = value; }
  
  void merge(Scope scope) => env.addAll(scope.env);

}