import '../lib/pegdart.dart';
import 'package:unittest/unittest.dart';

class TestGrammar extends Grammar {
  initialize() {
    rule(#start, m('a').many.any);
  }
}

main() {
  
  test('Simple sequencing test.', () {
    var grammar = new TestGrammar()..initialize();
    expect(grammar.parse('aaaa').map((r) => r.match), ['a', 'a', 'a', 'a']);
  });
  
  test('Sequencing failure.', () {
    var grammar = new TestGrammar()..initialize();
    expect(grammar.parse(''), Ignore);
  });
  
}