import '../lib/pegdart.dart';
import 'package:unittest/unittest.dart';

class TestGrammar extends Grammar {
  initialize() {
    rule(#start, r('\\d').many[#digits]);
  } 
}

main() {
  
  test('Regular expression matching.', () {
    var grammar = new TestGrammar()..initialize();
    expect(grammar.parse('123'), ['1', '2', '3']);
  });
  
}